angular.module('starter.controllers', ['ipCookie'])

    .controller('AppCtrl', function ($scope, $cordovaSplashscreen) {
        $cordovaSplashscreen.show();
    })

    .controller("TabsCtrl", function ($rootScope, $state) {
        // 二级页面隐藏标签
        $rootScope.$on('$ionicView.beforeEnter', function () {
            var stateName = $state.current.name;
            if (stateName === 'app.home' || stateName === 'app.store-list' || stateName === 'app.account') {
                $rootScope.hideTabs = false;

            } else {
                $rootScope.hideTabs = true;
            }
        });
    })
    .controller('homeCtrl', function ($scope, $ionicScrollDelegate, Banners, NavMenu, $timeout, $ionicSlideBoxDelegate, $ionicModal, Products, Version, $http, $cordovaToast, User) {

        $scope.filter = function (data) {
            console.log(data);
        }
        // 轮播 
        $timeout(function () {
            $ionicSlideBoxDelegate.update();
            $ionicSlideBoxDelegate.loop(true);
        }, 1000)
        // 回到顶部
        $scope.scrollTop = function () {
            $ionicScrollDelegate.scrollTop(true);
            $scope.scroll = false;
        }

        // 下拉刷新
        $scope.refresh = function () {
            $timeout(function () {
                Products.query(function (data) {
                    $scope.products = data;
                    localStorage['list'] = JSON.stringify(data);
                    console.log("刷新list");
                }, function (err) {
                    $cordovaToast.showShortBottom('刷新失败！')
                })
                $scope.$broadcast('scroll.refreshComplete');
            }, 1000)
        }

        $scope.loading = true;
        if (localStorage['banners']) {
            $scope.banners = JSON.parse(localStorage['banners']);
        }
        if (localStorage['list']) {
            $scope.products = JSON.parse(localStorage['list']);
        };
        Version.save('banner', function (data) {
            // 版本最新，无需操作
            console.log("bannerVersion:" + data[0].version)
            //先加载
            if (localStorage['banners'] && localStorage['bannerVersion'] && localStorage['bannerVersion'] == data[0].version) {
                console.log("banner使用缓存");
                console.log($scope.banners);
            } else {
                Banners.query(function (data) {
                    $scope.banners = data;
                    localStorage['banners'] = JSON.stringify(data);
                    // $ionicSlideBoxDelegate.update();
                    // $ionicSlideBoxDelegate.loop(true);
                    // console.log("banner在线获取");
                    console.log(data);
                })
                localStorage['bannerVersion'] = data[0].version;
            }
        }, function (err) {
            console.log('error');
        });

        Version.save('product', function (data) {
            // 版本最新，无需操作
            console.log('listVersion:' + data[0].version)
            if (localStorage['list'] && localStorage.listVersion == data[0].version) {
                console.log("list使用缓存");
                console.log($scope.products);
            } else {
                // 如果版本太旧、或者没有缓存
                localStorage.listVersion = data[0].version;
                Products.query(function (data) {
                    $scope.products = data;
                    localStorage['list'] = JSON.stringify(data);
                    console.log("list在线获取");
                })
            }
        }, function (err) {
            if (localStorage['list']) {
                $scope.products = JSON.parse(localStorage['list']);
            } else {
                $scope.$broadcast("scroll.infiniteScrollComplete");
                $scope.loading = false;
            }
        })

        for (var i in $scope.products) {
            $scope.products[i]['nowprice'] = parseFloat($scope.products[i]['nowprice']);
        }

        // $scope.banners = Banners.query(function () {
        //     $ionicSlideBoxDelegate.update();
        //     // banner循环播放
        //     $ionicSlideBoxDelegate.loop(true);
        // });

        // if (!localStorage['banners']) {

        // } else {
        //     $scope.banners = JSON.parse(localStorage['banners']);
        //     console.log('banners缓存')
        // }

        $scope.navmenu = NavMenu.all();

        // 下拉搜索
        $ionicModal.fromTemplateUrl('templates/modal_search.html', {
            scope: $scope,
        }).then(function (modal) {
            $scope.search_modal = modal;
        })

        // 滚动加载
        // $scope.loadMore = function () {
        //     var items = [
        //         { title: '洗车一次', id: 1, src: '53566abcba8049a11140d96e9645e68e.jpg', orig: 30, price: 15, class: 1 },
        //         { title: '洗车加手工打蜡一次', id: 2, src: '67c97eba7ccec8248b2d1d034e66b9d0.jpg', orig: 30, price: 15, class: 2 },
        //         { title: ' 199矿物油小保养服务  ', id: 3, src: '470fb9f8bcd228f00cff70fa51282240.png', orig: 30, price: 15, class: 3 },
        //         { title: ' 299矿物油小保养服务  ', id: 4, src: '85918e3dbb2b403fae1e80bead15f302.png', orig: 30, price: 15, class: 2 },
        //         { title: ' 399矿物油小保养服务  ', id: 5, src: 'a8cadee8913c2798cd5ce07cbf803d1b.png', orig: 30, price: 15, class: 1 },
        //         { title: ' 499矿物油小保养服务  ', id: 6, src: 'b3febbdfe7affdb8f137f7d32c2c2a62.png', orig: 30, price: 15, class: 4 }
        //     ];
        //     $timeout(function () {
        //         $scope.homelist = $scope.homelist.concat(items);
        //         $scope.$broadcast("scroll.infiniteScrollComplete");
        //     }, 500)
        // }
    })

    .controller('accountCtrl', function ($scope, $ionicModal, User, $location, $ionicPopup) {
        $scope.setPhoneIsShow = function () {
            if (localStorage.userinfo) {
                if (!JSON.parse(localStorage.userinfo).phone) {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        }
        $scope.userinfo = {};
        $scope.logout = function () {
            // User.logout();
            $location.path('#/app/home');
            location.reload();
        }
        if (localStorage.userinfo) {
            if (JSON.parse(localStorage.userinfo)) {
                $scope.userinfo = JSON.parse(localStorage.userinfo);
            } else {
                localStorage.removeItem('userinfo');
            }
            // alert('userinfo:' + JSON.stringify($scope.userinfo));
            $scope.url = '#/app/mine';
        } else {
            $scope.userinfo = {
                'nickname': '尚未登录',
                'headimgurl': 'img/list/6.jpg'
            }
            $scope.url = '#/app/login';
            // localStorage.removeItem('userinfo');
        }

        $scope.clearLocal = function () {
            localStorage.clear();
            alert('退出登录');
            location.reload();
        }

        // 更改手机号
        $scope.setPhonePop = function () {
            $scope.user = {}
            $ionicPopup
                .show({
                    template: '<input type="text" ng-model="user.phone">',
                    title: '请输入手机号',
                    // subTitle: 'Please use normal things',
                    scope: $scope,
                    buttons: [
                        { text: '取消' },
                        {
                            text: '确认',
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.user.phone) {
                                    //不允许用户关闭，除非他输入信息
                                    e.preventDefault();
                                } else {
                                    User.setPhone({ 'openid': 'test', 'phone': $scope.user.phone }, function (res) {
                                        console.log(res);
                                    }, function (err) {
                                        console.log(err);
                                    });
                                    // return $scope.user.phone;
                                }
                            }
                        },
                    ]
                })
        }

    })
    .controller('productListCtrl', function ($scope, Products, $ionicModal, $timeout) {
        // Products.all().success(function (data) {
        //     $scope.products = data;
        //     console.log($scope.products)
        // })

        $scope.products = Products.query(function (data) {
            console.log(data)
        })

        // 下拉搜索
        $ionicModal.fromTemplateUrl('templates/modal_search.html', {
            scope: $scope,
        }).then(function (modal) {
            $scope.search_modal = modal;
        })

    })

    .controller('productItemCtrl', function ($scope, $http, $stateParams, ProductItem, $ionicLoading, $ionicPopup) {
        $ionicLoading.show();
        $scope.item = {};
        ProductItem.save($stateParams.id, function (data) {
            $scope.item = data[0];
            $ionicLoading.hide();
            console.log($scope.item);
            // eval(data)
            // console.log(eval(json));
        }, function (err) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: '加载失败'
            });
        })

    })
    .controller('placeOrderCtrl', function ($scope, $ionicModal, $ionicPopup, Store, Coupon, Products, Version, ProductItem, $stateParams, $ionicLoading, Wechat, $http) {
        $ionicLoading.show();
        // 获取门店信息
        Version.save('shop', function (data) {
            // 版本最新，无需操作
            console.log('shopVersion:' + JSON.stringify(data[0]))
            if (localStorage.shopVersion == data[0]) {
                $scope.storeList = JSON.parse(localStorage['shop']);
                console.log("shop使用缓存")
            } else {
                // 如果版本太旧、或者没有缓存
                localStorage.shopVersion = data[0];
                Store.query(function (data) {
                    $scope.storeList = data;
                    localStorage['shop'] = JSON.stringify(data);
                    console.log("shop在线获取")
                })
            }

        }, function (err) {
            $ionicPopup.alert({
                title: '警告',
                template: '数据获取失败'
            });
            $ionicLoading.hide();
        })

        $scope.datenow = new Date().getTime();
        $scope.couponList = Coupon.query(function (data) {
            for (var i in data) {
                data[i].deadline = new Date(data[i].end_time * 1000)
                // console.log(data[i].end_time + today);
            }
            $scope.couponList = data;
        });
        // 商品信息

        if (!Array.prototype.find) {
            Object.defineProperty(Array.prototype, 'find', {
                enumerable: false,
                configurable: true,
                writable: true,
                value: function (predicate) {
                    if (this == null) {
                        throw new TypeError('Array.prototype.find called on null or undefined');
                    }
                    if (typeof predicate !== 'function') {
                        throw new TypeError('predicate must be a function');
                    }
                    var list = Object(this);
                    var length = list.length >>> 0;
                    var thisArg = arguments[1];
                    var value;

                    for (var i = 0; i < length; i++) {
                        if (i in list) {
                            value = list[i];
                            if (predicate.call(thisArg, value, i, list)) {
                                return value;
                            }
                        }
                    }
                    return undefined;
                }
            });
        }
        if (localStorage.list) {
            $scope.product = JSON.parse(localStorage.list).find(function (data) {
                return data.id == $stateParams.id;
            });
        } else {
            $scope.product = "";

        }
        $ionicLoading.hide();

        function getTotalFee() {
            if ($scope.product && $scope.coupon && $scope.product.nowprice && $scope.coupon.price) {
                return $scope.product.nowprice - $scope.coupon.price;
            } else if ($scope.product && $scope.product.nowprice) {
                return $scope.product.nowprice * 100;
            } else {
                return false;
            }
        }
        // 弹出框
        $scope.popup = function () {
            $ionicPopup.show({
                template: ' <ion-list>\
                                <ion-radio ng-model="choice" ng-value="A"  checked="checked">微信支付</ion-radio>\
                            </ion-list>',
                title: '支付方式',
                scope: $scope,
                buttons: [
                    {
                        text: '取消'
                    },
                    {
                        text: '付款',
                        type: 'button-assertive',
                        onTap: function () {
                            var data = {}
                            if (getTotalFee()) {
                                data.total_fee = getTotalFee();
                            } else {
                                alert('价格错误');
                                return false;
                            }
                            if ($scope.product.flag) {
                                data.body = $scope.product.flag;
                            } else {
                                alert('flag is not defined');
                                return false;
                            }
                            data.item_id = $stateParams.id;
                            data.user_id = localStorage.userid;
                            //TODO 抵扣券id;
                            $ionicLoading.show();
                            // alert(JSON.stringify(data));
                            Wechat.sendPaymentRequest(data, function (res) {
                                $ionicLoading.hide();
                                // 付款成功
                            }, function (err) {
                                // 付款失败
                                $ionicLoading.hide();
                                alert(err);
                            });
                        }
                    }]
            })
        }

        // 门店选择
        $ionicModal.fromTemplateUrl('templates/modal-store.html', {
            scope: $scope
        }).then(function (modal) {
            $scope.storeList_modal = modal;
        })

        $scope.storeChoice = function (item) {
            $scope.store = item;
            console.log($scope.store)
            $scope.storeList_modal.hide();
        }

        // 时间选择
        $scope.yytime = "";

        // 抵扣券选择
        $scope.couponName;
        $ionicModal.fromTemplateUrl('templates/modal-coupon.html', {
            scope: $scope
        }).then(function (modal) {
            $scope.coupon_modal = modal;
        })

        $scope.couponChoice = function (item) {
            $scope.coupon = item;
            $scope.coupon_modal.hide();
        }
    })

    .controller('loginCtrl', function ($scope, $http, $ionicLoading, Wechat, $ionicHistory, User, $rootScope, $state) {
        // $scope.login = function () {
        //     User.login();
        //     $location.path('#/app/home');
        //     location.reload()
        // }
        // Wechat.isInstall();
        $scope.login = function () {
            $ionicLoading.show();
            Wechat.login(function (res) {
                // alert(JSON.stringify(res));
                localStorage.userinfo = JSON.stringify(res);
                User.add(res, function (data) {
                    // alert(JSON.stringify(data));
                    localStorage.userid = data[0].id;
                    location.href = '#/app/account';
                    location.reload();
                    $ionicLoading.hide();
                }, function (err) {
                    // alert(err);
                    $ionicLoading.hide();
                })
            }, function (err) {
                // alert(err);
                $ionicLoading.hide();
            })
        }
    })

    .controller('storeList', function ($scope, $http, Store) {
        $scope.storeList = Store.query(function (data) {
            $scope.storeList = data;
        });
    })
    .controller('orderCtrl', function ($scope, $http, Groupon, Order, $ionicScrollDelegate, $ionicTabsDelegate, $ionicPopup, $timeout) {
        // 下拉刷新
        $scope.refresh = function () {
            $timeout(function () {
                Order.save(data, function (data) {
                    $scope.orderList = data;
                    for (var i in data) {
                        $scope.orderList[i]['buytime'] = new Date(data[i]['buytime']);
                    }
                    console.log(data);
                }, function (err) {
                    $ionicPopup.alert({
                        title: '警告',
                        template: '加载失败'
                    })
                })
                $scope.$broadcast('scroll.refreshComplete');
            }, 1000)
        }

        $scope.orderStatus = {
            0: "已消费",
            1: "待付款",
            2: "未消费",
            3: "退款中",
            4: "已退款",
        }
        if (localStorage.userid) {
            var data = {
                "userid": localStorage.userid
            }
            Order.save(data, function (data) {
                $scope.orderList = data;
                for (var i in data) {
                    $scope.orderList[i]['buytime'] = new Date(data[i]['buytime']).getTime();
                }
                console.log(data);
            }, function (err) {
                $ionicPopup.alert({
                    title: '警告',
                    template: '加载失败'
                })
            })
        } else {
            console.log("未登录或cookie被清除");
            $scope.orderList = "";
        }
    })

    .controller('orderDetailCtrl', function ($scope, $stateParams, Order, $ionicPopup, ReFund, $state) {
        $scope.orderStatus = {
            0: "已消费",
            1: "待付款",
            2: "未消费",
            3: "退款中",
            4: "已退款",
            5: "已消费"
        }
        Order.save({ "orderid": $stateParams.id }, function (data) {
            $scope.order = data[0];
            console.log(data[0]);
        })
        $scope.barOptions = {
            width: 1,
            height: 50,
            quite: 10,
            displayValue: true,
            font: "monospace",
            textAlign: "center",
            fontSize: 24,
            backgroundColor: "",
            lineColor: "#000"
        };
        $scope.qrcode = "123";


        // 弹出框
        $scope.refund = function () {
            $ionicPopup.show({
                title: '是否退款',
                scope: $scope,
                buttons: [{ text: '取消' }, {
                    text: '确定', type: 'button-assertive', onTap: function () {
                        ReFund.save($stateParams.id, function (data) {
                            alert(data.msg)
                            console.log(data);
                            $state.go('app.order');
                            location.reload();
                        })
                    }
                }]
            })
        }
    })

    .controller('couponCtrl', function ($scope, Coupon) {
        $scope.couponList = Coupon.query(function (data) {
            for (var i in data) {
                data[i].deadline = new Date(data[i].end_time * 1000)
                // console.log(data[i].end_time + today);
            }
            $scope.couponList = data;
        });
    })