angular.module('starter.router', ['ionic'])
    .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
        
        $ionicConfigProvider.platform.android.tabs.position('bottom');
        
        $stateProvider
            .state('app', {
                url: '/app',
                abstract: true,
                templateUrl: 'templates/tabs.html',
                controller: 'TabsCtrl'
            })

            .state('app.home', {
                url: '/home',
                views: {
                    'home': {
                        templateUrl: 'templates/home.html',
                        controller: 'homeCtrl'
                    }
                }
            })

            .state('app.product-list', {
                url: '/product',
                views: {
                    'home': {
                        templateUrl: 'templates/product-list.html',
                        controller: 'productListCtrl'
                    }
                }
            })

            .state('app.product-item', {
                url: '/product/:id',
                views: {
                    'home': {
                        templateUrl: 'templates/product-item.html',
                        controller: 'productItemCtrl'
                    }
                }

            })

            .state('app.order', {
                url: '/order',
                cache:false,
                views: {
                    'account': {
                        templateUrl: 'templates/order.html',
                        controller: "orderCtrl"
                    }
                }
            })

            .state('app.panel', {
                url: '/panel',
                views: {
                    'tab-tab1': {
                        templateUrl: 'templates/panel.html'
                    }
                }
            })

            .state('app.buy', {
                url: '/buy/:id',
                views: {
                    'home': {
                        templateUrl: 'templates/order-submit.html',
                        controller: 'placeOrderCtrl'
                    }
                }
            })

            .state('app.groupon', {
                url: '/groupon',
                views: {
                    'home': {
                        templateUrl: 'templates/groupon.html'
                    }
                }
            })

            .state('app.coupon', {
                url: '/coupon',
                views: {
                    'account': {
                        templateUrl: 'templates/coupon.html',
                        controller: 'placeOrderCtrl'
                    }
                }
            })

            .state('app.account', {
                url: '/account',
                cache:false,
                views: {
                    'account': {
                        templateUrl: 'templates/account.html',
                        controller: 'accountCtrl'
                    }
                }
            })

            .state('app.store-list', {
                url: '/store',
                views: {
                    'store': {
                        templateUrl: 'templates/store-list.html',
                        controller: 'storeList'
                    }
                }
            })

            .state('app.login', {
                url: '/login',
                views: {
                    'account': {
                        templateUrl: 'templates/login.html',
                        controller: 'loginCtrl'
                    }
                }
            })

            .state('app.account-detail', {
                url: '/account-detail',
                view: {
                    'account': {
                        templateUrl: 'templates/account-detail.html'
                    }
                }
            })

            .state('app.order-detail', {
                url: '/order-detail/:id',
                views: {
                    'home': {
                        templateUrl: 'templates/order-detail.html',
                        controller: 'orderDetailCtrl'
                    }
                }
            })

            .state('app.demo', {
                url: '/demo',
                views: {
                    'home': {
                        templateUrl: 'templates/demo.html',
                        controller: 'DemoCtrl'
                    }
                }
            })


        $urlRouterProvider.otherwise('/app/home');
    });
