angular.module('starter.router', ['ionic'])
    .config(function ($stateProvider, $urlRouterProvider) {

        $stateProvider

            .state('app', {
                url: '/app',
                abstract: true,
                templateUrl: 'templates/side-menu.html'
            })

            .state('app.home', {
                url: '/home',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/home.html',
                        controller: 'homeCtrl'
                    }
                }
            })

            .state('app.product-list', {
                url: '/product',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/product-list.html',
                        controller: 'productListCtrl'
                    }
                }
            })

            .state('app.product-item', {
                url: '/product/:id',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/product-item.html',
                        controller: 'productItemCtrl'
                    }
                }

            })

            .state('app.order', {
                url: '/order',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/order.html',
                        controller: "orderCtrl"
                    }
                }
            })

            .state('app.buy', {
                url: '/buy/:id',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/order-submit.html',
                        controller: 'placeOrderCtrl'
                    }
                }
            })

            .state('app.groupon', {
                url: '/groupon',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/groupon.html'
                    }
                }
            })

            .state('app.coupon', {
                url: '/coupon',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/coupon.html',
                        controller: 'couponCtrl'
                    }
                }
            })

            .state('app.account', {
                url: '/account',
                cache:false,
                views: {
                    'menuContent': {
                        templateUrl: 'templates/account.html',
                        controller: 'accountCtrl'
                    }
                }
            })


            .state('app.mine', {
                url: '/mine',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/mine.html'
                    }
                }
            })

            .state('app.store-list', {
                url: '/store',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/store-list.html',
                        controller: 'storeList'
                    }
                }
            })

            .state('app.login', {
                url: '/login',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/login.html',
                        controller: 'loginCtrl'
                    }
                }
            })

            .state('app.order-detail', {
                url: '/order/:id',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/order-detail.html',
                        controller: 'orderDetailCtrl'
                    }
                }
            })

            .state('app.demo', {
                url: '/demo',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/demo.html',
                        controller: 'DemoCtrl'
                    }
                }
            })

            .state('app.panel', {
                url: '/panel',
                views: {
                    'tab-tab1': {
                        templateUrl: 'templates/panel.html'
                    }
                }
            })

        // .state('app.side-menu',{
        //   url:'/menu',
        //   views:{
        //     'side-menu':{
        //       templateUrl:'templates/side-menu.html'
        //     }
        //   }
        // })
        // .state('app.goods-detail', {
        //   url: '/goods/:id',
        //   views: {
        //     'menuContent': {
        //       templateUrl: 'templates/goods-detail.html',
        //       controller: 'goodsCtrl'
        //     }
        //   }
        // })

        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/app/home');
    });
