angular.module('starter.services', ['ipCookie', 'ngResource'])
    .factory('Version', function ($resource, ENV, $http) {
        var url = ENV.api + '/apiVersion.php'
        return $resource(url, {}, {
            'save': {
                method: 'POST',
                isArray: 'true'
            }
        });
    })
    .factory('Banners', function ($http, $resource, ENV) {
        var url = ENV.api + "/apiBanner.php";
        return $resource(url);
    })

    .factory('NavMenu', function () {
        var navMenu = [
            { src: '1.png', title: '精致洗车' },
            { src: '2.png', title: '汽车检测' },
            { src: '3.png', title: '极致养护' },
            { src: '4.png', title: '小保养' }
        ]
        return {
            all: function () {
                return navMenu;
            }
        }
    })
    .factory('Products', function ($resource, ENV) {
        var url = ENV.api + "/apiList.php"
        return $resource(url);
    })
    .factory('ProductItem', function ($resource, ENV, $http) {
        var url = ENV.api + "/apiItem.php"
        return $resource(url, {}, {
            'save': {
                method: 'POST',
                isArray: true
            }
        });
        // return {
        //     get: function (data) {
        //         return $http.post(url, data);
        //     }
        // }
    })

    .factory('Store', function ($resource, ENV) {
        var url = ENV.api + '/apiShop.php';
        return $resource(url);
    })


    .factory('Coupon', function ($resource, ENV) {
        var url = ENV.api + "/apiCoupon.php";
        return $resource(url)
    })

    .factory('Groupon', function ($resource, ENV) {
        var url = ENV.api + '/apiGroupon.php'
        return $resource(url, {}, {
            'save': {
                method: 'POST',
                isArray: true
            }
        });
    })

    .factory('User', function (ipCookie, $http, ENV, $resource) {
        return {
            add: function (data,res,err) {
                var url = ENV.api + '/apiUser.php?action=adduserinfo';
                $http.post(url,data)
                .success(res)
                .error(err);
            },
            login: function () {
                var url = ENV.api + '/apiLogin.php';
                $http.get(url)
                    .success(function (data) {
                        ipCookie("unionid", data.result, { expires: 30, expirationUnit: 'days' });
                        console.log(ipCookie("unionid"))
                    })
            },
            logout: function () {
                ipCookie.remove("unionid");
            },
            isLogin: function () {
                return !!ipCookie("unionid");
            },
            setPhone: function (data, success, err) {
                var url = ENV.api + '/apiUser.php?action=setphone';
                if (data && data.openid && data.phone) {
                    $http.post(url, data)
                        .success(success)
                        .error(err);
                } else {
                    errr('参数不正确');
                }
            }
        }
    })

    .factory('Pwd', function () {
        return {
            encode: function (pwd) {
                // 匹配是否有双引号、单引号、斜杠、反斜杠等特殊字符
                var regExp = /\"|\'|\\|\//g;
                if (regExp.test(pwd)) {
                    return false;
                }
                // 随机字母
                function randomLetter(len) {
                    var arrNum = [];
                    var arrLetter = [];
                    if (!!len && typeof len === 'number') {
                        while (arrNum.length < len) {
                            var rdNum = Math.floor(Math.random() * 57 + 65);
                            if (rdNum > 97 || rdNum < 90) {
                                arrNum.push(rdNum)
                            }
                        }
                    }
                    for (var i in arrNum) {
                        arrLetter.push(String.fromCharCode(arrNum[i]))
                    }
                    return arrLetter.join("");
                }
                pwd = pwd.split("");
                var str = "";
                for (var i in pwd) {
                    str += pwd[i] + randomLetter(2);
                }
                return str;
            },
            decode: function (pwd) {
                var str = "";
                for (var i = 0; i < pwd.length; i += 3) {
                    str += pwd[i];
                }
                return str;
            }
        }
    })

    .factory('Order', function ($resource, ENV) {
        var url = ENV.api + '/apiOrder.php?query'
        return $resource(url, {}, {
            'save': {
                method: 'POST',
                isArray: true
            }
        });
    })

    .factory('ReFund', function ($resource, ENV) {
        var url = ENV.api + '/apiRefund.php';
        return $resource(url);
    })

    .factory('Wechat', function ($http, ENV) {
        return {
            isInstall: function () {
                if (typeof Wechat === 'undefined') {
                    return false;
                }
                else {
                    return true;
                }
                // return res();
            },

            auth: function (res, err) {
                if (this.isInstall()) {
                    var scope = "snsapi_userinfo",
                        state = "_" + (+new Date());
                    Wechat.auth(scope, state, res, err);
                } else {
                    err('Wechat is not install');
                }
            },

            login: function (res, err) {
                this.auth(function (data) {
                    var url = 'https://api.weixin.qq.com/sns/oauth2/access_token?appid=' + ENV.appid + '&secret=' + ENV.secret + '&code=' + data.code + '&grant_type=authorization_code';
                    $http.get(url)
                        .success(function (data) {
                            $http.get('https://api.weixin.qq.com/sns/userinfo?access_token=' + data.access_token + '&openid=' + data.openid + '')
                                .success(res)
                                .error(err)
                        })
                        .error(err)
                }, err)
            },
            sendPaymentRequest: function (data, res, err) {
                if (this.isInstall()) {
                    var params = {};
                    var url = ENV.api + '/apiPayment.php';
                    $http.post(url, data).success(function (data) {
                        params = {
                            prepayid: data.prepayid,
                            partnerid: data.partnerid,
                            noncestr: data.noncestr,
                            timestamp: data.timestamp,
                            sign: data.sign
                        }
                        // alert(JSON.stringify(params));
                        Wechat.sendPaymentRequest(params, res, err);
                    })
                } else {
                    err('Wechat is not install');
                }
            },
        }
    })